import processing.core.*; import processing.opengl.*; import krister.Ess.*; import net.fladdict.oscillator.*; import controlP5.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class psynthtronic070 extends PApplet {

 



PImage fondo;

ControlP5 controlP5;
Patchera[] patchs;
int patchC=0;

AudioStream myStream; 
float[] streamBuffer; 
Oscillator osc;
Oscillator osc2;
Oscillator osc3;
Oscillator osc4;
float oscPer1,oscPer2,oscPer3,oscPer4;

float multiplicador1=50.0f;
float multiplicador2=50.0f;
float multiplicador3=0.5f;
float multiplicador1b=1.0f;

int wave1tipo=0;
int modo2tipo=0;
int modo3tipo=0;
boolean doAmp1=true;
boolean doPer1=false;
float slider1=0.2f;
float paneo=0.0f;

int bloqAIndice=0;
int bloqASign=1;

boolean keyOpen1=false;
float keyStep1=0.0f;
float keyVal1=0.0f;
int keyEnd1=0;

boolean keyOpen2=false;
float keyStep2=0.0f;
float keyVal2=0.0f;
int keyEnd2=0;

boolean keyOpen3=false;
float keyStep3=0.0f;
float keyVal3=0.0f;
int keyEnd3=0;

boolean doOSC=true;
boolean mute=true;

PitchShift myPitchShift;
int cuenta=0;
public void setup() { 
  size(1150,600,OPENGL); 
  
  fondo = loadImage("interfaceAudio8.png");

  Ess.start(this); 
  myStream=new AudioStream(); 
  myStream.sampleRate(22050); 
  myStream.bufferSize(22050/12);
  //myStream.bufferSize(22000);   
  //println(myStream.size);
  streamBuffer=new float[myStream.size];
  osc = new OscSin(1,100);
  osc2 = new OscSin(1,128);
  osc3 = new OscSin(1,128);
  osc4 = new OscSin(1,128);
  oscPer1=100.0f;
  oscPer2=128.0f;
  oscPer3=128.0f;
  oscPer4=128.0f;
  //fillAudioBuffer(); 
  myStream.start(); 
  controlP5 = new ControlP5(this);
  controlP5.addKnob("knob1",0,2000,128,27,290,40);
  controlP5.addKnob("knob1b",0,300,100,27,345,40);
  controlP5.addKnob("knob2",0,1000,128,104,290,40);
  controlP5.addKnob("knob3",0,200,50,104,345,40);
  controlP5.addKnob("knob4",0,1000,128,179,290,40);
  controlP5.addKnob("knob5",0,200,50,179,345,40);
  controlP5.addKnob("knob6",0,100000,128,283,70,40);
  controlP5.addToggle("doOSC",true,268,50,10,10).setLabel("do");
  controlP5.addToggle("mute",true,325,50,10,10);
  controlP5.addNumberbox("knob6v",128,268,350,50,20);
  controlP5.addButton("SETVEL",0,268,390,50,20);
  controlP5.addKnob("knob7",0,200,50,283,130,40);
  Radio r = controlP5.addRadio("wave1",24,420);
  r.add("sin",0);
  r.add("cos",1);
  r.add("triangle",2);
  r.add("square",3);
  r.add("sawt",4);
  r.add("sawt2",5);
  Radio r2 = controlP5.addRadio("wave2",100,420);
  r2.add("sin",0);
  r2.add("cos",1);
  r2.add("triangle",2);
  r2.add("square",3);
  r2.add("sawt",4);
  r2.add("sawt2",5);
  controlP5.addToggle("doAmp1",true,100,510,10,10);
  r2 = controlP5.addRadio("wave3",178,420);
  r2.add("sin",0);
  r2.add("cos",1);
  r2.add("triangle",2);
  r2.add("square",3);
  r2.add("sawt",4);
  r2.add("sawt2",5);
  controlP5.addToggle("doPer1",false,178,510,10,10);
  r2 = controlP5.addRadio("wave4",268,240);
  r2.add("sin",0);
  r2.add("cos",1);
  r2.add("triangle",2);
  r2.add("square",3);
  r2.add("sawt",4);
  r2.add("sawt2",5);
  controlP5.addSlider("slider1",0.0f,2.0f,0.2f,268,190,34,10).setLabel("CUTOFF");;
  controlP5.addSlider("paneo",-1.0f,1.0f,0.0f,268,204,34,10);
  
  controlP5.addNumberbox("copy1",0,268,448,30,10);
  controlP5.addNumberbox("copy2",0,303,448,30,10);
  controlP5.addButton("DOCOPY",10,268,480,65,20);
  
  patchs=new Patchera[4];
  patchs[0]=new Patchera(this,360,380,0);
  patchs[1]=new Patchera(this,760,380,1);
  patchs[2]=new Patchera(this,360,80,2);
  patchs[3]=new Patchera(this,760,80,3);
  //myStream.pan(-1);
} 


public void draw() { 
  //osc.setPeriod(mouseX);
  //translate(0,0,-mouseX);
  background(100);
  image(fondo,0,0);
  fill(255,0,141);
  /*if(bloqAIndice<8){
   rect(356,300,370,200);
   }
   else{
   rect(720,300,370,200);
   }*/
  if(patchC!=-1){
    rect(patchs[patchC].x-3,patchs[patchC].y-33,365,233);
  }
  stroke(255);
  for(int i=0; i<myStream.size-1; i++) {
    //if(i%8==0){
    //point(i/10,100-(myStream.buffer[i])*50);
    //}
    line(27+i/10,115-(myStream.buffer[i])*25,37+i/10,115-(myStream.buffer[i+1])*25);
  }
  noStroke();
} 

public void audioStreamWrite(AudioStream theStream) {
  //fillAudioBuffer(); 
  //System.arraycopy(streamBuffer,0,myStream.buffer,0,streamBuffer.length);
  //background(100);
  //stroke(255);
  myStream.pan(paneo);
  for(int i=0; i<myStream.size; i++) {
    osc2.update();
    osc3.update();
    osc4.update();
    cuenta++;
    float bb = osc4.getValue();
    boolean cambio=false;
    if(doOSC){
    if(bb>0 && bloqASign<0){
      bloqASign=1;
      cambio=true;
    }
    else if(bb<0 && bloqASign>0){
      bloqASign=-1;
      cambio=true;
    }
    if(cambio){
      bloqAIndice++;
      if(bloqAIndice==8){
        bloqAIndice=0;
        patchC++;
        if(patchC==patchs.length){
          patchC=0;
        }
        boolean activo=false;
        int cacti=0;
        while(!activo){
          Controller cc1=patchs[(cacti+patchC)%patchs.length].controlP5.controller("PATCH");
          float vacti= cc1.value();
          if(vacti==1.0f){
            activo = true;
            patchC=(cacti+patchC)%patchs.length;
          }
          else{
            cacti++;
            if(cacti>patchs.length){
              activo=true;
              patchC=-1;
            }
          }
        }
      }
      if(patchC!=-1){
        checkKeyFrame1();
        checkKeyFrame2();
        checkKeyFrame3();
      }
      cuenta=0;
    }
    }else{
      patchC=-1;
    }
    float o1=oscPer1;
    float o2=oscPer2;
    float o3=oscPer3;

    if(patchC!=-1){
      o1+=keyVal1;
      keyVal1+=keyStep1;
      o2+=keyVal2;
      keyVal2+=keyStep2;
      o3+=keyVal3;
      keyVal3+=keyStep3;
      //float o4=oscPer4;
      Controller cc1=patchs[patchC].controlP5.controller("modif"+(bloqAIndice+1));
      Controller cc2=patchs[patchC].controlP5.controller("modifB"+(bloqAIndice+1));
      Controller cc3=patchs[patchC].controlP5.controller("modifC"+(bloqAIndice+1));
      o1+=cc1.value();
      o2+=cc2.value();
      o3+=cc3.value();
    }
    osc.setPeriod(o1);
    osc2.setPeriod(o2);
    osc3.setPeriod(o3);

    if(doAmp1==true){
      osc.setAmpOffset(osc2.getValue()*(multiplicador1/100.0f));
    }
    else{
      osc.setAmpOffset(0);
    }
    if(doPer1==true){
      osc.setPerOffset(osc3.getValue()*multiplicador2);
    }
    else{
      osc.setPerOffset(0);
    }

    osc.setAmplitude(multiplicador1b);
    osc.update();

    boolean e=true;
    if(patchC!=-1){
      Controller bl=patchs[patchC].controlP5.controller("bloq"+(bloqAIndice+1));
      if(bl.value()==1.0f){
        e=true;
      }
      else{
        e=false;
      }
    }
    if(e && !mute){
      if(doOSC){
        myStream.buffer[i]=osc.getValue()*(osc4.getValue()*multiplicador3);
      }else{
        myStream.buffer[i]=osc.getValue();
      }
      if(abs(myStream.buffer[i])<slider1){
        myStream.buffer[i]=0.0f;
      }
    }
    else{
      myStream.buffer[i]=0.0f;
    }
    //if(i%8==0){
    //point(i/10,200-(theStream.buffer[i])*0.5);
    //}
  }

  myPitchShift.filter(myStream);
  //noStroke();
} 

public void stop() { 
  Ess.stop(); 
  super.stop(); 
} 
public void knob1(int valor) {
  //osc.setPeriod(valor);
  oscPer1=valor;
}
public void knob2(int valor) {
  //osc2.setPeriod(valor);
  oscPer2=valor;
}
public void knob4(int valor) {
  //osc3.setPeriod(valor);
  oscPer3=valor;
}
public void knob6(int valor) {
  osc4.setPeriod(valor);
  oscPer4=valor;
  Controller c=controlP5.controller("knob6v");
  c.setValue(valor);
}
public void knob6v(float v){
  /*Controller c=controlP5.controller("knob6");
  c.setValue(v);
  osc4.setPeriod(v);
  oscPer4=v;*/
}
public void knob3(int valor) {
  multiplicador1=valor;
}
public void knob5(int valor) {
  multiplicador2=valor;
}
public void knob7(int valor) {
  multiplicador3=valor/100.0f;
}
public void knob1b(int valor) {
  multiplicador1b=valor/100.0f;
}
public void wave1(int theID) {
  wave1tipo=theID;
  Controller c=controlP5.controller("knob1");
  switch(theID) {
    case(0):
    osc = new OscSin(1,c.value());
    break; 
    case(1):
    osc = new OscCos(1,c.value());
    break;  
    case(2):
    osc = new OscTriangle(1,c.value());
    break;  
    case(3):
    osc = new OscSquare(1,c.value());
    break;  
    case(4):
    osc = new OscSawTooth(1,c.value());
    break;
    case(5):
    osc = new OscSawTooth2(1,c.value());
    break;
  }
}
public void wave2(int theID) {
  Controller c=controlP5.controller("knob2");
  switch(theID) {
    case(0):
    osc2 = new OscSin(1,c.value());
    break; 
    case(1):
    osc2 = new OscCos(1,c.value());
    break;  
    case(2):
    osc2 = new OscTriangle(1,c.value());
    break;  
    case(3):
    osc2 = new OscSquare(1,c.value());
    break;  
    case(4):
    osc2 = new OscSawTooth(1,c.value());
    break;
    case(5):
    osc2 = new OscSawTooth2(1,c.value());
    break;
  }
}
public void wave3(int theID) {
  Controller c=controlP5.controller("knob4");
  switch(theID) {
    case(0):
    osc3 = new OscSin(1,c.value());
    break; 
    case(1):
    osc3 = new OscCos(1,c.value());
    break;  
    case(2):
    osc3 = new OscTriangle(1,c.value());
    break;  
    case(3):
    osc3 = new OscSquare(1,c.value());
    break;  
    case(4):
    osc3 = new OscSawTooth(1,c.value());
    break;
    case(5):
    osc3 = new OscSawTooth2(1,c.value());
    break;
  }
}
public void wave4(int theID) {
  Controller c=controlP5.controller("knob6");
  switch(theID) {
    case(0):
    osc4 = new OscSin(1,c.value());
    break; 
    case(1):
    osc4 = new OscCos(1,c.value());
    break;  
    case(2):
    osc4 = new OscTriangle(1,c.value());
    break;  
    case(3):
    osc4 = new OscSquare(1,c.value());
    break;  
    case(4):
    osc4 = new OscSawTooth(1,c.value());
    break;
    case(5):
    osc4 = new OscSawTooth2(1,c.value());
    break;
  }
}
public void modo2(int theID) {
  modo2tipo=theID;

  //Controller c=controlP5.controller("knob3");
}
public void checkKeyFrame1(){
  int ini=-1;
  int fin=-1;
  float inicial=0.0f;
  float acaba=0.0f;
  if(keyOpen1==true){
    if(keyEnd1==bloqAIndice+1){
      keyOpen1=false;
    }
  }
  if(bloqAIndice<7){
    Controller bb1=patchs[patchC].controlP5.controller("key"+(bloqAIndice+1));
    Controller mo1=patchs[patchC].controlP5.controller("modifD"+(bloqAIndice+1));
    float k1=bb1.value();
    if(k1==1.0f){
      ini=bloqAIndice+1;
      inicial=mo1.value();
      acaba=0.0f;
      for(int i=bloqAIndice+2;i<=8;i++){
        Controller bb2=patchs[patchC].controlP5.controller("key"+i);
        float k2=bb2.value();
        if(k2==1.0f){
          fin=i;
          Controller mo2=patchs[patchC].controlP5.controller("modifD"+i);
          acaba=mo2.value();
          i=8;
        }
      }
    }
  }
  if(keyOpen1==false){
    if(fin!=-1 && ini!=-1){
      int dif=fin-ini;
      float pasos=dif*oscPer4;
      keyStep1=(acaba-inicial)/pasos;
      keyVal1=inicial;
      keyOpen1=true;
      keyEnd1=fin;
    }
    else{
      keyVal1=0.0f;
      keyStep1=0.0f;
    }
  }
}
public void checkKeyFrame2(){
  int ini=-1;
  int fin=-1;
  float inicial=0.0f;
  float acaba=0.0f;
  if(keyOpen2==true){
    if(keyEnd2==bloqAIndice+1){
      keyOpen2=false;
    }
  }
  if(bloqAIndice<7){
    Controller bb1=patchs[patchC].controlP5.controller("keyB"+(bloqAIndice+1));
    Controller mo1=patchs[patchC].controlP5.controller("modifE"+(bloqAIndice+1));
    float k1=bb1.value();
    if(k1==1.0f){
      ini=bloqAIndice+1;
      inicial=mo1.value();
      acaba=0.0f;
      for(int i=bloqAIndice+2;i<=8;i++){
        Controller bb2=patchs[patchC].controlP5.controller("keyB"+i);
        float k2=bb2.value();
        if(k2==1.0f){
          fin=i;
          Controller mo2=patchs[patchC].controlP5.controller("modifE"+i);
          acaba=mo2.value();
          i=8;
        }
      }
    }
  }
  if(keyOpen2==false){
    if(fin!=-1 && ini!=-1){
      int dif=fin-ini;
      float pasos=dif*oscPer4;
      keyStep2=(acaba-inicial)/pasos;
      keyVal2=inicial;
      keyOpen2=true;
      keyEnd2=fin;
    }
    else{
      keyVal2=0.0f;
      keyStep2=0.0f;
    }
  }
}
public void checkKeyFrame3(){
  int ini=-1;
  int fin=-1;
  float inicial=0.0f;
  float acaba=0.0f;
  if(keyOpen3==true){
    if(keyEnd3==bloqAIndice+1){
      keyOpen3=false;
    }
  }
  if(bloqAIndice<7){
    Controller bb1=patchs[patchC].controlP5.controller("keyC"+(bloqAIndice+1));
    Controller mo1=patchs[patchC].controlP5.controller("modifF"+(bloqAIndice+1));
    float k1=bb1.value();
    if(k1==1.0f){
      ini=bloqAIndice+1;
      inicial=mo1.value();
      acaba=0.0f;
      for(int i=bloqAIndice+2;i<=8;i++){
        Controller bb2=patchs[patchC].controlP5.controller("keyC"+i);
        float k2=bb2.value();
        if(k2==1.0f){
          fin=i;
          Controller mo2=patchs[patchC].controlP5.controller("modifF"+i);
          acaba=mo2.value();
          i=8;
        }
      }
    }
  }
  if(keyOpen3==false){
    if(fin!=-1 && ini!=-1){
      int dif=fin-ini;
      float pasos=dif*oscPer4;
      keyStep3=(acaba-inicial)/pasos;
      keyVal3=inicial;
      keyOpen3=true;
      keyEnd3=fin;
    }
    else{
      keyVal3=0.0f;
      keyStep3=0.0f;
    }
  }
}
public void DOCOPY(int v){
  Controller cv1=controlP5.controller("copy1");
  Controller cv2=controlP5.controller("copy2");
  
  int v1=(int)cv1.value();
  int v2=(int)cv2.value();
  if(v1<0 || v1>=patchs.length || v2<0 || v2>=patchs.length || v1==v2){
    return;
  }
  for(int i=1;i<=8;i++){
    patchs[v2].controlP5.controller("bloq"+i).setValue(patchs[v1].controlP5.controller("bloq"+i).value());
    patchs[v2].controlP5.controller("modif"+i).setValue(patchs[v1].controlP5.controller("modif"+i).value());
    patchs[v2].controlP5.controller("modifB"+i).setValue(patchs[v1].controlP5.controller("modifB"+i).value());
    patchs[v2].controlP5.controller("modifC"+i).setValue(patchs[v1].controlP5.controller("modifC"+i).value());
    patchs[v2].controlP5.controller("modifD"+i).setValue(patchs[v1].controlP5.controller("modifD"+i).value());
    patchs[v2].controlP5.controller("modifE"+i).setValue(patchs[v1].controlP5.controller("modifE"+i).value());
    patchs[v2].controlP5.controller("modifF"+i).setValue(patchs[v1].controlP5.controller("modifF"+i).value());
    patchs[v2].controlP5.controller("key"+i).setValue(patchs[v1].controlP5.controller("key"+i).value());
    patchs[v2].controlP5.controller("keyB"+i).setValue(patchs[v1].controlP5.controller("keyB"+i).value());
    patchs[v2].controlP5.controller("keyC"+i).setValue(patchs[v1].controlP5.controller("keyC"+i).value());
  }
}
public void SETVEL(float valor){
  float v=controlP5.controller("knob6v").value();
  Controller c=controlP5.controller("knob6");
  c.setValue(v);
  osc4.setPeriod(v);
  oscPer4=v;
}

class Patchera{
  boolean key1=false;
  boolean key2=false;
  boolean key3=false;
  boolean key4=false;
  boolean key5=false;
  boolean key6=false;
  boolean key7=false;
  boolean key8=false;

  boolean keyB1=false;
  boolean keyB2=false;
  boolean keyB3=false;
  boolean keyB4=false;
  boolean keyB5=false;
  boolean keyB6=false;
  boolean keyB7=false;
  boolean keyB8=false;

  boolean keyC1=false;
  boolean keyC2=false;
  boolean keyC3=false;
  boolean keyC4=false;
  boolean keyC5=false;
  boolean keyC6=false;
  boolean keyC7=false;
  boolean keyC8=false;

  float modif1=0.0f;
  float modif2=0.0f;
  float modif3=0.0f;
  float modif4=0.0f;
  float modif5=0.0f;
  float modif6=0.0f;
  float modif7=0.0f;
  float modif8=0.0f;

  float modifB1=0.0f;
  float modifB2=0.0f;
  float modifB3=0.0f;
  float modifB4=0.0f;
  float modifB5=0.0f;
  float modifB6=0.0f;
  float modifB7=0.0f;
  float modifB8=0.0f;

  float modifC1=0.0f;
  float modifC2=0.0f;
  float modifC3=0.0f;
  float modifC4=0.0f;
  float modifC5=0.0f;
  float modifC6=0.0f;
  float modifC7=0.0f;
  float modifC8=0.0f;

  float modifD1=0.0f;
  float modifD2=0.0f;
  float modifD3=0.0f;
  float modifD4=0.0f;
  float modifD5=0.0f;
  float modifD6=0.0f;
  float modifD7=0.0f;
  float modifD8=0.0f;

  float modifE1=0.0f;
  float modifE2=0.0f;
  float modifE3=0.0f;
  float modifE4=0.0f;
  float modifE5=0.0f;
  float modifE6=0.0f;
  float modifE7=0.0f;
  float modifE8=0.0f;

  float modifF1=0.0f;
  float modifF2=0.0f;
  float modifF3=0.0f;
  float modifF4=0.0f;
  float modifF5=0.0f;
  float modifF6=0.0f;
  float modifF7=0.0f;
  float modifF8=0.0f;

  boolean bloq1=true;
  boolean bloq2=true;
  boolean bloq3=true;
  boolean bloq4=true;
  boolean bloq5=true;
  boolean bloq6=true;
  boolean bloq7=true;
  boolean bloq8=true;
  
  int x=0;
  int y=0;
  int indice=0;
  ControlP5 controlP5;
  Patchera(PApplet p, int px, int py, int in){
    x=px;
    y=py;
    controlP5= new ControlP5(p);
    controlP5.addToggle("PATCH",true,x,y-30,10,10);
    Controller c=controlP5.controller("PATCH");
    c.setLabel("PATCH "+in);
    indice=in;
    controlP5.addToggle("bloq1",true,x,y,10,10);
    controlP5.addToggle("bloq2",true,x,y+25,10,10);
    controlP5.addToggle("bloq3",true,x,y+50,10,10);
    controlP5.addToggle("bloq4",true,x,y+75,10,10);
    controlP5.addToggle("bloq5",true,x,y+100,10,10);
    controlP5.addToggle("bloq6",true,x,y+125,10,10);
    controlP5.addToggle("bloq7",true,x,y+150,10,10);
    controlP5.addToggle("bloq8",true,x,y+175,10,10);
    //myPitchShift=new PitchShift(Ess.calcShift(3));
    controlP5.addNumberbox("modif1",0,x+40,y,30,10);
    controlP5.addNumberbox("modif2",0,x+40,y+25,30,10);
    controlP5.addNumberbox("modif3",0,x+40,y+50,30,10);
    controlP5.addNumberbox("modif4",0,x+40,y+75,30,10);
    controlP5.addNumberbox("modif5",0,x+40,y+100,30,10);
    controlP5.addNumberbox("modif6",0,x+40,y+125,30,10);
    controlP5.addNumberbox("modif7",0,x+40,y+150,30,10);
    controlP5.addNumberbox("modif8",0,x+40,y+175,30,10);

    controlP5.addNumberbox("modifB1",0,x+80,y,30,10);
    controlP5.addNumberbox("modifB2",0,x+80,y+25,30,10);
    controlP5.addNumberbox("modifB3",0,x+80,y+50,30,10);
    controlP5.addNumberbox("modifB4",0,x+80,y+75,30,10);
    controlP5.addNumberbox("modifB5",0,x+80,y+100,30,10);
    controlP5.addNumberbox("modifB6",0,x+80,y+125,30,10);
    controlP5.addNumberbox("modifB7",0,x+80,y+150,30,10);
    controlP5.addNumberbox("modifB8",0,x+80,y+175,30,10);

    controlP5.addNumberbox("modifC1",0,x+120,y,30,10);
    controlP5.addNumberbox("modifC2",0,x+120,y+25,30,10);
    controlP5.addNumberbox("modifC3",0,x+120,y+50,30,10);
    controlP5.addNumberbox("modifC4",0,x+120,y+75,30,10);
    controlP5.addNumberbox("modifC5",0,x+120,y+100,30,10);
    controlP5.addNumberbox("modifC6",0,x+120,y+125,30,10);
    controlP5.addNumberbox("modifC7",0,x+120,y+150,30,10);
    controlP5.addNumberbox("modifC8",0,x+120,y+175,30,10);

    controlP5.addNumberbox("modifD1",0,x+160,y,30,10);
    controlP5.addNumberbox("modifD2",0,x+160,y+25,30,10);
    controlP5.addNumberbox("modifD3",0,x+160,y+50,30,10);
    controlP5.addNumberbox("modifD4",0,x+160,y+75,30,10);
    controlP5.addNumberbox("modifD5",0,x+160,y+100,30,10);
    controlP5.addNumberbox("modifD6",0,x+160,y+125,30,10);
    controlP5.addNumberbox("modifD7",0,x+160,y+150,30,10);
    controlP5.addNumberbox("modifD8",0,x+160,y+175,30,10);

    controlP5.addToggle("key1",false,x+200,y,10,10);
    controlP5.addToggle("key2",false,x+200,y+25,10,10);
    controlP5.addToggle("key3",false,x+200,y+50,10,10);
    controlP5.addToggle("key4",false,x+200,y+75,10,10);
    controlP5.addToggle("key5",false,x+200,y+100,10,10);
    controlP5.addToggle("key6",false,x+200,y+125,10,10);
    controlP5.addToggle("key7",false,x+200,y+150,10,10);
    controlP5.addToggle("key8",false,x+200,y+175,10,10);

    controlP5.addNumberbox("modifE1",0,x+220,y,30,10);
    controlP5.addNumberbox("modifE2",0,x+220,y+25,30,10);
    controlP5.addNumberbox("modifE3",0,x+220,y+50,30,10);
    controlP5.addNumberbox("modifE4",0,x+220,y+75,30,10);
    controlP5.addNumberbox("modifE5",0,x+220,y+100,30,10);
    controlP5.addNumberbox("modifE6",0,x+220,y+125,30,10);
    controlP5.addNumberbox("modifE7",0,x+220,y+150,30,10);
    controlP5.addNumberbox("modifE8",0,x+220,y+175,30,10);

    controlP5.addToggle("keyB1",false,x+260,y,10,10);
    controlP5.addToggle("keyB2",false,x+260,y+25,10,10);
    controlP5.addToggle("keyB3",false,x+260,y+50,10,10);
    controlP5.addToggle("keyB4",false,x+260,y+75,10,10);
    controlP5.addToggle("keyB5",false,x+260,y+100,10,10);
    controlP5.addToggle("keyB6",false,x+260,y+125,10,10);
    controlP5.addToggle("keyB7",false,x+260,y+150,10,10);
    controlP5.addToggle("keyB8",false,x+260,y+175,10,10);

    controlP5.addNumberbox("modifF1",0,x+280,y,30,10);
    controlP5.addNumberbox("modifF2",0,x+280,y+25,30,10);
    controlP5.addNumberbox("modifF3",0,x+280,y+50,30,10);
    controlP5.addNumberbox("modifF4",0,x+280,y+75,30,10);
    controlP5.addNumberbox("modifF5",0,x+280,y+100,30,10);
    controlP5.addNumberbox("modifF6",0,x+280,y+125,30,10);
    controlP5.addNumberbox("modifF7",0,x+280,y+150,30,10);
    controlP5.addNumberbox("modifF8",0,x+280,y+175,30,10);

    controlP5.addToggle("keyC1",false,x+320,y,10,10);
    controlP5.addToggle("keyC2",false,x+320,y+25,10,10);
    controlP5.addToggle("keyC3",false,x+320,y+50,10,10);
    controlP5.addToggle("keyC4",false,x+320,y+75,10,10);
    controlP5.addToggle("keyC5",false,x+320,y+100,10,10);
    controlP5.addToggle("keyC6",false,x+320,y+125,10,10);
    controlP5.addToggle("keyC7",false,x+320,y+150,10,10);
    controlP5.addToggle("keyC8",false,x+320,y+175,10,10);
  }
}

  static public void main(String args[]) {     PApplet.main(new String[] { "psynthtronic070" });  }}