import processing.opengl.*;

import krister.Ess.*; 
import net.fladdict.oscillator.*;
import controlP5.*;

PImage fondo;

ControlP5 controlP5;
Patchera[] patchs;
int patchC=0;

AudioStream myStream; 
float[] streamBuffer; 
Oscillator osc;
Oscillator osc2;
Oscillator osc3;
Oscillator osc4;
float oscPer1,oscPer2,oscPer3,oscPer4;

float multiplicador1=50.0;
float multiplicador2=50.0;
float multiplicador3=0.5;
float multiplicador1b=1.0;

int wave1tipo=0;
int modo2tipo=0;
int modo3tipo=0;
boolean doAmp1=true;
boolean doPer1=false;
float slider1=0.2;
float paneo=0.0;

int bloqAIndice=0;
int bloqASign=1;

boolean keyOpen1=false;
float keyStep1=0.0;
float keyVal1=0.0;
int keyEnd1=0;

boolean keyOpen2=false;
float keyStep2=0.0;
float keyVal2=0.0;
int keyEnd2=0;

boolean keyOpen3=false;
float keyStep3=0.0;
float keyVal3=0.0;
int keyEnd3=0;

boolean doOSC=true;
boolean mute=true;

PitchShift myPitchShift;
int cuenta=0;
void setup() { 
  size(1150,600,OPENGL); 
  
  fondo = loadImage("interfaceAudio8.png");

  Ess.start(this); 
  myStream=new AudioStream(); 
  myStream.sampleRate(22050); 
  myStream.bufferSize(22050/12);
  //myStream.bufferSize(22000);   
  //println(myStream.size);
  streamBuffer=new float[myStream.size];
  osc = new OscSin(1,100);
  osc2 = new OscSin(1,128);
  osc3 = new OscSin(1,128);
  osc4 = new OscSin(1,128);
  oscPer1=100.0;
  oscPer2=128.0;
  oscPer3=128.0;
  oscPer4=128.0;
  //fillAudioBuffer(); 
  myStream.start(); 
  controlP5 = new ControlP5(this);
  controlP5.addKnob("knob1",0,2000,128,27,290,40);
  controlP5.addKnob("knob1b",0,300,100,27,345,40);
  controlP5.addKnob("knob2",0,1000,128,104,290,40);
  controlP5.addKnob("knob3",0,200,50,104,345,40);
  controlP5.addKnob("knob4",0,1000,128,179,290,40);
  controlP5.addKnob("knob5",0,200,50,179,345,40);
  controlP5.addKnob("knob6",0,100000,128,283,70,40);
  controlP5.addToggle("doOSC",true,268,50,10,10).setLabel("do");
  controlP5.addToggle("mute",true,325,50,10,10);
  controlP5.addNumberbox("knob6v",128,268,350,50,20);
  controlP5.addButton("SETVEL",0,268,390,50,20);
  controlP5.addKnob("knob7",0,200,50,283,130,40);
  Radio r = controlP5.addRadio("wave1",24,420);
  r.add("sin",0);
  r.add("cos",1);
  r.add("triangle",2);
  r.add("square",3);
  r.add("sawt",4);
  r.add("sawt2",5);
  Radio r2 = controlP5.addRadio("wave2",100,420);
  r2.add("sin",0);
  r2.add("cos",1);
  r2.add("triangle",2);
  r2.add("square",3);
  r2.add("sawt",4);
  r2.add("sawt2",5);
  controlP5.addToggle("doAmp1",true,100,510,10,10);
  r2 = controlP5.addRadio("wave3",178,420);
  r2.add("sin",0);
  r2.add("cos",1);
  r2.add("triangle",2);
  r2.add("square",3);
  r2.add("sawt",4);
  r2.add("sawt2",5);
  controlP5.addToggle("doPer1",false,178,510,10,10);
  r2 = controlP5.addRadio("wave4",268,240);
  r2.add("sin",0);
  r2.add("cos",1);
  r2.add("triangle",2);
  r2.add("square",3);
  r2.add("sawt",4);
  r2.add("sawt2",5);
  controlP5.addSlider("slider1",0.0,2.0,0.2,268,190,34,10).setLabel("CUTOFF");;
  controlP5.addSlider("paneo",-1.0,1.0,0.0,268,204,34,10);
  
  controlP5.addNumberbox("copy1",0,268,448,30,10);
  controlP5.addNumberbox("copy2",0,303,448,30,10);
  controlP5.addButton("DOCOPY",10,268,480,65,20);
  
  patchs=new Patchera[4];
  patchs[0]=new Patchera(this,360,380,0);
  patchs[1]=new Patchera(this,760,380,1);
  patchs[2]=new Patchera(this,360,80,2);
  patchs[3]=new Patchera(this,760,80,3);
  //myStream.pan(-1);
} 


void draw() { 
  //osc.setPeriod(mouseX);
  //translate(0,0,-mouseX);
  background(100);
  image(fondo,0,0);
  fill(255,0,141);
  /*if(bloqAIndice<8){
   rect(356,300,370,200);
   }
   else{
   rect(720,300,370,200);
   }*/
  if(patchC!=-1){
    rect(patchs[patchC].x-3,patchs[patchC].y-33,365,233);
  }
  stroke(255);
  for(int i=0; i<myStream.size-1; i++) {
    //if(i%8==0){
    //point(i/10,100-(myStream.buffer[i])*50);
    //}
    line(27+i/10,115-(myStream.buffer[i])*25,37+i/10,115-(myStream.buffer[i+1])*25);
  }
  noStroke();
} 

void audioStreamWrite(AudioStream theStream) {
  //fillAudioBuffer(); 
  //System.arraycopy(streamBuffer,0,myStream.buffer,0,streamBuffer.length);
  //background(100);
  //stroke(255);
  myStream.pan(paneo);
  for(int i=0; i<myStream.size; i++) {
    osc2.update();
    osc3.update();
    osc4.update();
    cuenta++;
    float bb = osc4.getValue();
    boolean cambio=false;
    if(doOSC){
    if(bb>0 && bloqASign<0){
      bloqASign=1;
      cambio=true;
    }
    else if(bb<0 && bloqASign>0){
      bloqASign=-1;
      cambio=true;
    }
    if(cambio){
      bloqAIndice++;
      if(bloqAIndice==8){
        bloqAIndice=0;
        patchC++;
        if(patchC==patchs.length){
          patchC=0;
        }
        boolean activo=false;
        int cacti=0;
        while(!activo){
          Controller cc1=patchs[(cacti+patchC)%patchs.length].controlP5.controller("PATCH");
          float vacti= cc1.value();
          if(vacti==1.0){
            activo = true;
            patchC=(cacti+patchC)%patchs.length;
          }
          else{
            cacti++;
            if(cacti>patchs.length){
              activo=true;
              patchC=-1;
            }
          }
        }
      }
      if(patchC!=-1){
        checkKeyFrame1();
        checkKeyFrame2();
        checkKeyFrame3();
      }
      cuenta=0;
    }
    }else{
      patchC=-1;
    }
    float o1=oscPer1;
    float o2=oscPer2;
    float o3=oscPer3;

    if(patchC!=-1){
      o1+=keyVal1;
      keyVal1+=keyStep1;
      o2+=keyVal2;
      keyVal2+=keyStep2;
      o3+=keyVal3;
      keyVal3+=keyStep3;
      //float o4=oscPer4;
      Controller cc1=patchs[patchC].controlP5.controller("modif"+(bloqAIndice+1));
      Controller cc2=patchs[patchC].controlP5.controller("modifB"+(bloqAIndice+1));
      Controller cc3=patchs[patchC].controlP5.controller("modifC"+(bloqAIndice+1));
      o1+=cc1.value();
      o2+=cc2.value();
      o3+=cc3.value();
    }
    osc.setPeriod(o1);
    osc2.setPeriod(o2);
    osc3.setPeriod(o3);

    if(doAmp1==true){
      osc.setAmpOffset(osc2.getValue()*(multiplicador1/100.0));
    }
    else{
      osc.setAmpOffset(0);
    }
    if(doPer1==true){
      osc.setPerOffset(osc3.getValue()*multiplicador2);
    }
    else{
      osc.setPerOffset(0);
    }

    osc.setAmplitude(multiplicador1b);
    osc.update();

    boolean e=true;
    if(patchC!=-1){
      Controller bl=patchs[patchC].controlP5.controller("bloq"+(bloqAIndice+1));
      if(bl.value()==1.0){
        e=true;
      }
      else{
        e=false;
      }
    }
    if(e && !mute){
      if(doOSC){
        myStream.buffer[i]=osc.getValue()*(osc4.getValue()*multiplicador3);
      }else{
        myStream.buffer[i]=osc.getValue();
      }
      if(abs(myStream.buffer[i])<slider1){
        myStream.buffer[i]=0.0;
      }
    }
    else{
      myStream.buffer[i]=0.0;
    }
    //if(i%8==0){
    //point(i/10,200-(theStream.buffer[i])*0.5);
    //}
  }

  myPitchShift.filter(myStream);
  //noStroke();
} 

public void stop() { 
  Ess.stop(); 
  super.stop(); 
} 
void knob1(int valor) {
  //osc.setPeriod(valor);
  oscPer1=valor;
}
void knob2(int valor) {
  //osc2.setPeriod(valor);
  oscPer2=valor;
}
void knob4(int valor) {
  //osc3.setPeriod(valor);
  oscPer3=valor;
}
void knob6(int valor) {
  osc4.setPeriod(valor);
  oscPer4=valor;
  Controller c=controlP5.controller("knob6v");
  c.setValue(valor);
}
void knob6v(float v){
  /*Controller c=controlP5.controller("knob6");
  c.setValue(v);
  osc4.setPeriod(v);
  oscPer4=v;*/
}
void knob3(int valor) {
  multiplicador1=valor;
}
void knob5(int valor) {
  multiplicador2=valor;
}
void knob7(int valor) {
  multiplicador3=valor/100.0;
}
void knob1b(int valor) {
  multiplicador1b=valor/100.0;
}
void wave1(int theID) {
  wave1tipo=theID;
  Controller c=controlP5.controller("knob1");
  switch(theID) {
    case(0):
    osc = new OscSin(1,c.value());
    break; 
    case(1):
    osc = new OscCos(1,c.value());
    break;  
    case(2):
    osc = new OscTriangle(1,c.value());
    break;  
    case(3):
    osc = new OscSquare(1,c.value());
    break;  
    case(4):
    osc = new OscSawTooth(1,c.value());
    break;
    case(5):
    osc = new OscSawTooth2(1,c.value());
    break;
  }
}
void wave2(int theID) {
  Controller c=controlP5.controller("knob2");
  switch(theID) {
    case(0):
    osc2 = new OscSin(1,c.value());
    break; 
    case(1):
    osc2 = new OscCos(1,c.value());
    break;  
    case(2):
    osc2 = new OscTriangle(1,c.value());
    break;  
    case(3):
    osc2 = new OscSquare(1,c.value());
    break;  
    case(4):
    osc2 = new OscSawTooth(1,c.value());
    break;
    case(5):
    osc2 = new OscSawTooth2(1,c.value());
    break;
  }
}
void wave3(int theID) {
  Controller c=controlP5.controller("knob4");
  switch(theID) {
    case(0):
    osc3 = new OscSin(1,c.value());
    break; 
    case(1):
    osc3 = new OscCos(1,c.value());
    break;  
    case(2):
    osc3 = new OscTriangle(1,c.value());
    break;  
    case(3):
    osc3 = new OscSquare(1,c.value());
    break;  
    case(4):
    osc3 = new OscSawTooth(1,c.value());
    break;
    case(5):
    osc3 = new OscSawTooth2(1,c.value());
    break;
  }
}
void wave4(int theID) {
  Controller c=controlP5.controller("knob6");
  switch(theID) {
    case(0):
    osc4 = new OscSin(1,c.value());
    break; 
    case(1):
    osc4 = new OscCos(1,c.value());
    break;  
    case(2):
    osc4 = new OscTriangle(1,c.value());
    break;  
    case(3):
    osc4 = new OscSquare(1,c.value());
    break;  
    case(4):
    osc4 = new OscSawTooth(1,c.value());
    break;
    case(5):
    osc4 = new OscSawTooth2(1,c.value());
    break;
  }
}
void modo2(int theID) {
  modo2tipo=theID;

  //Controller c=controlP5.controller("knob3");
}
void checkKeyFrame1(){
  int ini=-1;
  int fin=-1;
  float inicial=0.0;
  float acaba=0.0;
  if(keyOpen1==true){
    if(keyEnd1==bloqAIndice+1){
      keyOpen1=false;
    }
  }
  if(bloqAIndice<7){
    Controller bb1=patchs[patchC].controlP5.controller("key"+(bloqAIndice+1));
    Controller mo1=patchs[patchC].controlP5.controller("modifD"+(bloqAIndice+1));
    float k1=bb1.value();
    if(k1==1.0){
      ini=bloqAIndice+1;
      inicial=mo1.value();
      acaba=0.0;
      for(int i=bloqAIndice+2;i<=8;i++){
        Controller bb2=patchs[patchC].controlP5.controller("key"+i);
        float k2=bb2.value();
        if(k2==1.0){
          fin=i;
          Controller mo2=patchs[patchC].controlP5.controller("modifD"+i);
          acaba=mo2.value();
          i=8;
        }
      }
    }
  }
  if(keyOpen1==false){
    if(fin!=-1 && ini!=-1){
      int dif=fin-ini;
      float pasos=dif*oscPer4;
      keyStep1=(acaba-inicial)/pasos;
      keyVal1=inicial;
      keyOpen1=true;
      keyEnd1=fin;
    }
    else{
      keyVal1=0.0;
      keyStep1=0.0;
    }
  }
}
void checkKeyFrame2(){
  int ini=-1;
  int fin=-1;
  float inicial=0.0;
  float acaba=0.0;
  if(keyOpen2==true){
    if(keyEnd2==bloqAIndice+1){
      keyOpen2=false;
    }
  }
  if(bloqAIndice<7){
    Controller bb1=patchs[patchC].controlP5.controller("keyB"+(bloqAIndice+1));
    Controller mo1=patchs[patchC].controlP5.controller("modifE"+(bloqAIndice+1));
    float k1=bb1.value();
    if(k1==1.0){
      ini=bloqAIndice+1;
      inicial=mo1.value();
      acaba=0.0;
      for(int i=bloqAIndice+2;i<=8;i++){
        Controller bb2=patchs[patchC].controlP5.controller("keyB"+i);
        float k2=bb2.value();
        if(k2==1.0){
          fin=i;
          Controller mo2=patchs[patchC].controlP5.controller("modifE"+i);
          acaba=mo2.value();
          i=8;
        }
      }
    }
  }
  if(keyOpen2==false){
    if(fin!=-1 && ini!=-1){
      int dif=fin-ini;
      float pasos=dif*oscPer4;
      keyStep2=(acaba-inicial)/pasos;
      keyVal2=inicial;
      keyOpen2=true;
      keyEnd2=fin;
    }
    else{
      keyVal2=0.0;
      keyStep2=0.0;
    }
  }
}
void checkKeyFrame3(){
  int ini=-1;
  int fin=-1;
  float inicial=0.0;
  float acaba=0.0;
  if(keyOpen3==true){
    if(keyEnd3==bloqAIndice+1){
      keyOpen3=false;
    }
  }
  if(bloqAIndice<7){
    Controller bb1=patchs[patchC].controlP5.controller("keyC"+(bloqAIndice+1));
    Controller mo1=patchs[patchC].controlP5.controller("modifF"+(bloqAIndice+1));
    float k1=bb1.value();
    if(k1==1.0){
      ini=bloqAIndice+1;
      inicial=mo1.value();
      acaba=0.0;
      for(int i=bloqAIndice+2;i<=8;i++){
        Controller bb2=patchs[patchC].controlP5.controller("keyC"+i);
        float k2=bb2.value();
        if(k2==1.0){
          fin=i;
          Controller mo2=patchs[patchC].controlP5.controller("modifF"+i);
          acaba=mo2.value();
          i=8;
        }
      }
    }
  }
  if(keyOpen3==false){
    if(fin!=-1 && ini!=-1){
      int dif=fin-ini;
      float pasos=dif*oscPer4;
      keyStep3=(acaba-inicial)/pasos;
      keyVal3=inicial;
      keyOpen3=true;
      keyEnd3=fin;
    }
    else{
      keyVal3=0.0;
      keyStep3=0.0;
    }
  }
}
void DOCOPY(int v){
  Controller cv1=controlP5.controller("copy1");
  Controller cv2=controlP5.controller("copy2");
  
  int v1=(int)cv1.value();
  int v2=(int)cv2.value();
  if(v1<0 || v1>=patchs.length || v2<0 || v2>=patchs.length || v1==v2){
    return;
  }
  for(int i=1;i<=8;i++){
    patchs[v2].controlP5.controller("bloq"+i).setValue(patchs[v1].controlP5.controller("bloq"+i).value());
    patchs[v2].controlP5.controller("modif"+i).setValue(patchs[v1].controlP5.controller("modif"+i).value());
    patchs[v2].controlP5.controller("modifB"+i).setValue(patchs[v1].controlP5.controller("modifB"+i).value());
    patchs[v2].controlP5.controller("modifC"+i).setValue(patchs[v1].controlP5.controller("modifC"+i).value());
    patchs[v2].controlP5.controller("modifD"+i).setValue(patchs[v1].controlP5.controller("modifD"+i).value());
    patchs[v2].controlP5.controller("modifE"+i).setValue(patchs[v1].controlP5.controller("modifE"+i).value());
    patchs[v2].controlP5.controller("modifF"+i).setValue(patchs[v1].controlP5.controller("modifF"+i).value());
    patchs[v2].controlP5.controller("key"+i).setValue(patchs[v1].controlP5.controller("key"+i).value());
    patchs[v2].controlP5.controller("keyB"+i).setValue(patchs[v1].controlP5.controller("keyB"+i).value());
    patchs[v2].controlP5.controller("keyC"+i).setValue(patchs[v1].controlP5.controller("keyC"+i).value());
  }
}
void SETVEL(float valor){
  float v=controlP5.controller("knob6v").value();
  Controller c=controlP5.controller("knob6");
  c.setValue(v);
  osc4.setPeriod(v);
  oscPer4=v;
}
